#!/usr/bin/perl

# tags and parses Kinyarwanda text (does not tokenize), one sentence per line, conll output format

use bytes;

# modify these lines as needed: ################################################
$tmp_folder = "/tmp/kparse";
$turbotagger = "/mal2/afm/TurboParser-2.0.2/TurboTagger";
$turboparser = "/mal2/afm/TurboParser-2.0.2/TurboParser";
################################################################################
$tag_model = "generated/kin/bigram-tagger.C1e-3.model";
$parse_model = "generated/kin/basic.C1e-3.tags-from-bigram-tagger.C1e-3.model";


system("mkdir -p $tmp_folder");
open(T, ">$tmp_folder/words");
while(<>) {
    (@W) = (split /\s+/);
    foreach $w (@W) { print T $w, "\t_\n"; }
    print T "\n";
}
close(T);
system("$turbotagger --test --file_model=$tag_model --file_test=$tmp_folder/words --file_prediction=$tmp_folder/tags --logtostderr 2> /dev/null");
open(I, "<$tmp_folder/tags");
open(O, ">$tmp_folder/conll");
$i = 0;
while($x = <I>){
    chomp($x);
    if($x eq "") { $i = 0; print O "\n"; }
    else {
	++$i;
	(@F) = (split /\s+/, $x);
	print O "$i\t$F[0]\t", lc($F[0]), "\t$F[1]\t$F[1]\t-\t-\t-\n";
    }
}
close(I);
close(O);
system("$turboparser --test --file_model=$parse_model --file_test=$tmp_folder/conll --file_prediction=$tmp_folder/output --logtostderr 2> /dev/null");
open(P, "<$tmp_folder/output");
while(<P>) { print; }
close(P);
system("rm -rf $tmp_folder");
